
% Example of parameter estimation for the binomial model from uncertain
% data using the E2M algorithm.
% Reproduces the example in Section 4.3 of
%
% T. Denoeux, Maximum likelihood estimation from Uncertain Data in the Belief
% Function Framework, IEEE Transactions on Knowledge and Data Engineering
% (to appear), 2011.
%
% Uses the function e2m_bernoulli
% Written by Thierry Denoeux, 11 Augut 2011.

p=[1 1 1 0 0 0]';
q=[0 0 0 1 1 1]';
theta=0:0.01:1;

figure(1);clf
hold on
for x=0:0.1:1,
    q(3)=x;
    p(3)=1-x;
    for i=1:length(theta),
        L(i)= prod((1-theta(i))*p+theta(i)*q);
    end;
    if x==0.5,
        plot(theta,L,'--');
    else,
        plot(theta,L);
    end;
    grid
    xlabel('\theta')
    ylabel('L(\theta;m)')
end;

x=0.5;
q(3)=x;
p(3)=1-x;
thetah=e2m_bernoulli(p,q,0.3,1);
