% Example of latent class model estimation
% Uses functions cluster_categ, add_noise
%
% Written by Thierry Denoeux, 11 Augut 2011.


clear
g=3; % 3 classes
p=3; % 3 attributes
r=[4 4 4]; % Each attribute has 4 modalities
n=500; % number of objects




% Model parameters

% attribute 1
alpha0(1,1,:)=[0.1 0.1 0.1 0.7]; % class 1
alpha0(2,1,:)=[0.1 0.1 0.7 0.1]; % class 2
alpha0(3,1,:)=[0.1 0.7 0.1 0.1]; % class 3

% attribute 2
alpha0(1,2,:)=[0.7 0.1 0.1 0.1]; % class 1
alpha0(2,2,:)=[0.1 0.1 0.1 0.7]; % class 2
alpha0(3,2,:)=[0.1 0.7 0.1 0.1]; % class 3

% attribute 3
alpha0(1,3,:)=[0.7 0.1 0.1 0.1]; % class 1
alpha0(2,3,:)=[0.1 0.7 0.1 0.1]; % class 2
alpha0(3,3,:)=[0.1 0.1 0.7 0.1]; % class 3

% Prior probabilities
pi0=ones(1,g)/g;



% Data generation
w=zeros(n,p);
plz=ones(n,g);
for i=1:n,
    R=mnrnd(1,pi0);
    z0(i)=find(R); % generate class
    for j=1:p,     % generate attributes
        R=mnrnd(1,squeeze(alpha0(z0(i),j,1:r(j))));
        w(i,j)=find(R);
    end;
end;

a=0.5;b=a; %  parameters of beta distribution with mean 0.5 and std dev 0.2
perr=betarnd(a,b,n,p); % randomly generates error probability
[pl,w1,pl1]=add_noise(w,perr,r); % pl1: wrong labels; pl: uncertain labels
                                 % w1: corrupted (noisy) labels


% E2M algorithm
visu=0;
nessai=5;
[alpha,pi,t,z]=cluster_categ(pl,plz,r,visu,nessai);




