% Example of Gaussian model estimation
% Uses functions cluster_norm
%
% Written by Thierry Denoeux, 11 Augut 2011.

g=3; % 3 classes
p=3; % 3 attributes
n=200; % 200 objects

% Model parameters

MU=3*[1 0 0;0 1 0;0 0 1];
SIG=zeros(1,p,g);
SIG(1,:,1)=[1 1 1];
SIG(1,:,2)=[1 1 1];
SIG(1,:,3)=[1 1 1];
pi0=ones(1,g)/3;

% Data generation

obj=gmdistribution(MU,SIG,pi0);
[w,z0]=random(obj,n);
plz=ones(n,g);

smax=1;
s=smax*rand(size(w));
m=w+s.*randn(size(w));
s2=s.^2;

% E2M algorithm
visu=0;
nessai=5;
[mu,sig2,pi,t,z,logLmax]=cluster_norm(m,s2,plz,visu,nessai);



